<template>
  <div>
    <el-card>
      <el-form :model="filterQuery" label-width="100px" size="mini">
        <el-row>
          <el-col :span="6">
            <el-form-item label="项目编码:" class="query-form-item">
              <el-input v-model="filterQuery.code" placeholder="请输入项目编码"></el-input>
            </el-form-item>
          </el-col>
          <el-col :span="6">
            <el-form-item label="项目名称:" class="query-form-item">
              <el-input v-model="filterQuery.name" placeholder="请输入项目名称"></el-input>
            </el-form-item>
          </el-col>
          <el-col :span="6">
            <el-form-item label="对照状态:">
              <el-select v-model="filterQuery.contrastStatus" style="width: 90%" placeholder="请选择对照状态">
                <el-option label="全部" value=""></el-option>
                <el-option label="未对照" value="1"></el-option>
                <el-option label="已对照" value="2"></el-option>
              </el-select>
            </el-form-item>
          </el-col>
        </el-row>
      </el-form>
      <el-divider></el-divider>
      <div class="top-right-btn" style="margin-top: -5px">
        <el-button-group>
          <el-button type="primary" icon="el-icon-refresh" @click="onReset">重置</el-button>
          <el-button type="primary" icon="el-icon-search" @click="onSubmit">查询</el-button>
          <el-button type="primary" icon="el-icon-download" @click="onDownload">更新下载</el-button>
          <el-button type="primary" icon="el-icon-plus" @click="handleAddClick">新增</el-button>
        </el-button-group>
      </div>
      <el-table v-loading="loading" :data="list" @current-change="handleDetail" border highlight-current-row
                style="width: 100%">
        <el-table-column label="序号" type="index"></el-table-column>
        <el-table-column label="项目编码" prop="code" width="140"></el-table-column>
        <el-table-column label="项目名称" prop="name" width="160"></el-table-column>
        <el-table-column label="规格型号" prop="ggxh" width="160"></el-table-column>
        <el-table-column label="价格" prop="price" width="160"></el-table-column>
        <el-table-column label="状态" prop="contrastStatus" show-overflow-tooltip width="120">
          <template slot-scope="scope">
            <el-tag :type="statusFilterType(scope.row.contrastStatus)">{{
                statusMap[scope.row.contrastStatus]
              }}
            </el-tag>
          </template>
        </el-table-column>

        <el-table-column label="备注" prop="remark" width="180"></el-table-column>
        <!--        <el-table-column label="创建人" prop="createByName" width="140"></el-table-column>-->
        <el-table-column label="更新时间" prop="createTime" width="160"></el-table-column>
        <el-table-column label="操作" width="160" fixed="right">
          <template slot-scope="scope">
            <el-button type="text" size="small" @click.native.stop="handleModifyClick(scope.row)">编辑</el-button>
            <el-button type="text" size="small" @click.native.stop="deleteDialog(scope.row)">删除</el-button>
            <!--            <el-button type="text" size="small" @click.native.stop="selectDialog(scope.row)">选入产品</el-button>-->
          </template>
        </el-table-column>
      </el-table>

      <pagination
        v-show="total>0"
        :total="total"
        :limit.sync="filterQuery.limit"
        :page.sync="filterQuery.page"
        @pagination="handleCurrentChange"
      ></pagination>
    </el-card>

    <el-card>

      <el-row>
        <el-col :span="24">
          <el-button type="primary" style="float: right;margin-bottom: 12px;margin-right: 20px" size="small"
                     icon="search" @click="selectProduct">新增产品
          </el-button>
        </el-col>
      </el-row>

      <el-table v-loading="loading" :data="delectList" border highlight-current-row style="width: 100%">
        <el-table-column label="序号" type="index"></el-table-column>
        <el-table-column label="DI/物资编码" prop="nameCode"></el-table-column>
        <el-table-column label="第三方编码" prop="thirdId"></el-table-column>
        <el-table-column label="物资名称" prop="cpmctymc"></el-table-column>
        <el-table-column label="规格型号" prop="ggxh"></el-table-column>
        <el-table-column label="计量单位" prop="measname"></el-table-column>
        <el-table-column label="数量" prop="count">
          <template slot-scope="scope">
            <el-input size="small" v-model="scope.row.count"
                      placeholder="请输入数量" style="width: 80%"
                      type='number'
                      :disabled="scope.row.index !== selectedIndex"
                      oninput="value=value.replace(/[^\d]/g,'')"></el-input>
          </template>
        </el-table-column>
        <el-table-column label="生产企业" prop="ylqxzcrbarmc"></el-table-column>
        <el-table-column label="注册/备案号" prop="zczbhhzbapzbh"></el-table-column>
        <el-table-column label="操作" width="220">
          <template slot-scope="scope">
            <el-button type="text" size="small" :disabled="scope.row.index === selectedIndex"
                       @click.native.stop="rowChange(scope.row)">编辑
            </el-button>
            <el-button type="text" size="small" :disabled="scope.row.index !== selectedIndex" @click.stop="true"
                       @click.native="tableCountChange(scope.row)">保存
            </el-button>
            <el-button type="text" size="small" @click.native.stop="delectModifyClick(scope.row)">移除</el-button>
          </template>
        </el-table-column>
      </el-table>
      <pagination
        v-show="delectTotal>0"
        :total="delectTotal"
        :limit.sync="delectQuery.limit"
        :page.sync="delectQuery.page"
        @pagination="handleCurrentDelectChange"
      ></pagination>
    </el-card>

    <el-dialog
      :title="formMap[formName]"
      :visible.sync="formVisible"
      :close-on-click-modal="false"
      :close-on-press-escape="false"
      width="45%"
      :before-close="closeDialog"
      v-if="formVisible"
    >
      <destinyModelEdit
        :editQuery="editQuery"
        :closeDialog="closeDialog"
        :type="2"
      ></destinyModelEdit>
    </el-dialog>

    <el-dialog
      title="选入产品"
      :visible.sync="selectFormVisible"
      append-to-body
      :close-on-click-modal="false"
      :close-on-press-escape="false"
      width="80%"
      :before-close="closeProudDialog"
      v-if="selectFormVisible"
    >
      <destinySelectProduct
        :editQuery="editLogin"
        :closeDialog="closeProudDialog"
      ></destinySelectProduct>
    </el-dialog>


  </div>
</template>

<script>
import {
  addModeldestiny,
  delectModeldestiny, delectModeldestinyProduct, downloadBasicProject,
  filterDestinyDelect,
  getBasicDestinyfilter, uploadModeldestinyProduct
} from "@/api/basic/basicDestinyRel";
import destinyModelEdit from "@/views/basic/destiny/destinyModelEdit";
import destinyModelSelectProduct from "@/views/basic/destiny/destinyModelSelectProduct";
import destinySelectProduct from "@/views/basic/destiny/destinySelectProduct";
import {downloadSick} from "@/api/basic/sicker/skPersonApi";


export default {
  data() {
    return {
      filterQuery: {
        name: "",
        code: "",
        type: 2,
        page: 1,
        limit: 20,
        contrastStatus: null,
      },
      editType: "",
      formVisible: false,
      selectFormVisible: false,
      loading: false,
      dlBasicLoading: false,
      formName: "",
      total: 0,
      list: [],
      codeArray: [],
      editQuery: {},
      formMap: {
        "add": "物资项目-新增",
        "edit": "物资项目-编辑"
      },
      delectQuery: {
        id: null,
        page: 1,
        limit: 20
      },
      delectList: [],
      delectTotal: 0,
      selectedIndex: '',

      editLogin: {
        id: null,
        cpmctymc: null,
        ids: [],
        page: 1,
        limit: 10,
      },
      statusMap: {
        1: "未对照",
        2: "已对照"
      },
    };
  },
  methods: {
    onReset() {
      this.$router.push({
        path: ""
      });
      this.filterQuery = {
        name: "",
        code: "",
        type: 2,
        page: 1,
        limit: 20
      };
      this.getList();
    },
    onSubmit() {
      this.$router.push({
        path: "",
      });
      this.filterQuery.page = 1;
      this.getList();
    },

    onDownload() {
      this.dlBasicLoading = true;
      downloadBasicProject({thidSys: "thirdId"}).then(res => {
        this.dlBasicLoading = false
        if (res.code != 20000) {
          this.$message.error(res.message)
          return
        }
      }).catch(() => {
        this.dlBasicLoading = false
        this.$message.error("数据加载失败")
      })
    },
    statusFilterType(status) {
      const statusMap = {
        1: 'warning',
        2: 'success'
      }
      return statusMap[status]
    },
    getList() {
      this.loading = true;
      getBasicDestinyfilter(this.filterQuery).then(response => {
        this.loading = false;
        this.list = response.data.list || [];
        this.total = response.data.total || 0;
      }).catch(() => {
        this.loading = false;
        this.list = [];
        this.total = 0;
        this.roles = [];
      });
    },
    handleCurrentChange(val) {
      this.filterQuery.page = val.page;
      this.getList();
    },
    handleCurrentDelectChange(val) {
      this.delectQuery.page = val.page;
      this.filterDestinyDelect()
    },
    handleAddClick() {
      this.formName = "add";
      this.formVisible = true;
    },
    handleModifyClick(row) {
      this.formName = "edit";
      this.formVisible = true;
      this.editQuery = row;
    },
    deleteDialog(row) {
      this.$confirm("删除该项目,项目底下所有产品也会被移除，是否确定删除?", "提示", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning",
      }).then(() => {
        this.loading = true;
        delectModeldestiny(row).then(res => {
          if (res.code == 20000) {
            this.getList();
          } else {
            this.$message.error(res.message);
          }
        }).catch(() => {
          this.$message.error("删除失败！");
        });
      }).catch(() => {
      });


    },
    selectDialog(row) {
      this.selectFormVisible = true;
      this.editQuery = row;
    },
    closeDialog() {
      this.formVisible = false;
      this.selectFormVisible = false;
      this.getList();
      this.delectList = []
      this.editQuery = {}
    },
    handleDetail(row) {
      this.delectQuery.id = row.id
      this.editQuery = row;
      this.filterDestinyDelect()
    },
    filterDestinyDelect() {
      if (this.delectQuery.id == null) return;
      filterDestinyDelect(this.delectQuery)
        .then((response) => {
          this.loading = false;
          if (response.code === 20000) {
            this.delectList = response.data.list || [];
            this.delectTotal = response.data.total || 0;
          } else {
            this.$message.error(response.message);
            this.delectList = [];
            this.delectTotal = 0;
          }
        })
        .catch(() => {
          this.loading = false;
          this.delectList = [];
          this.delectTotal = 0;
        });
    },
    rowChange(val) {
      this.selectedIndex = val.index
    },
    tableCountChange(row) {
      if (this.$isNotBlank(row)) {
        var query = {
          id: row.deId,
          count: row.count
        }
        uploadModeldestinyProduct(query);
        this.selectedIndex = null
      }
    },
    delectModifyClick(row) {
      this.$confirm("是否确定移除该产品?", "提示", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning",
      }).then(() => {
        this.loading = true;
        let tquery = {
          id: row.deId
        };
        delectModeldestinyProduct(tquery)
          .then((response) => {
            this.loading = false;
            if (response.code === 20000) {
              this.filterDestinyDelect();
              this.$message({
                type: "success",
                message: "删除成功！",
              });
            } else {
              this.$message.error(response.message);
            }
          })
          .catch(() => {
            this.certLoading = false;
          });
      }).catch(() => {
      });
    },
    selectProduct() {
      this.editLogin.id = this.editQuery.id
      this.selectFormVisible = true;
    },
    closeProudDialog() {
      this.selectFormVisible = false;
      this.filterDestinyDelect();
    },
  }
  ,
  mounted() {
  }
  ,
  components: {
    destinyModelEdit, destinyModelSelectProduct, destinySelectProduct
  }
  ,
  created() {
    this.filterQuery.name = this.$route.query.cpmctymc;
    if (this.filterQuery.name != null) {
      this.getList()
    }
    this.getList();
  }
}
;
</script>
